#!/usr/local/bin/tclsh8.4
#!/usr/bin/tclsh

package require Tk

lappend auto_path [file dirname [info script]]
package require BSFiles 1.0
package require BSLoginWindow 1.0
package require BSMainWindow 1.0

#
# Setup
#
# Parameters:
#	none
#
# Return:
#	none
#	error
#
proc Setup {} {
	global argv
		
	# initial list of files to upload
	::BSFiles::AddFiles $argv
		
	# configure login window behavior
	::BSLoginWindow::Setup \
			::ShowMainWindow
	
	# configure main window behavior
	::BSMainWindow::Setup \
			::BSLoginWindow::Username \
			::ShowLoginWindow
	
	# make the login window
	ShowLoginWindow
}

#
# ShowLoginWindow
#
# Parameters:
#	none
#
# Return:
#	none
#
proc ShowLoginWindow {} {
	::BSLoginWindow::MakeLoginWindow
	wm protocol . WM_DELETE_WINDOW ::QuitLoginWindow
}

#
# ShowMainWindow
#
# Parameters:
#	none
#
# Return:
#	none
#
proc ShowMainWindow {} {
	::BSMainWindow::MakeMainWindow
	wm protocol . WM_DELETE_WINDOW ::QuitMainWindow
}

#
# QuitLoginWindow
#
# Parameters:
#	none
#
# Return:
#	none (may exit)
#
proc QuitLoginWindow {} {
	if {[::BSLoginWindow::IsBusy]} {
		set choice [tk_messageBox -type yesno -icon question -message "Authentication in progress. Quit anyway?"]
		if {$choice eq yes} {
			exit 0
		}
	} else {
		exit 0
	}
}

#
# QuitMainWindow
#
# Parameters:
#	none
#
# Return:
#	none (may exit)
#
proc QuitMainWindow {} {
	if {[::BSMainWindow::IsBusy]} {
		set choice [tk_messageBox -type yesno -icon question -message "Upload in progress. Quit anyway?"]
		if {$choice eq yes} {
			exit 0
		}
	} else {
		exit 0
	}
}

# Start
if {[catch {Setup} err]} {
	puts stderr $err
	exit 1
}
