package provide BSFiles 1.0

namespace eval BSFiles {

# list of file paths
variable files {}

# public procedures
namespace export Reference Count Files AddFiles RemoveFiles

#
# Reference
#
# Parameters:
#	none
#
# Return:
#	name of file list variable
#
proc Reference {} {
	return ::BSFiles::files
}

#
# Count
#
# Parameters:
#	none
#
# Return:
#	number of files
#
proc Count {} {
	variable files
	return [llength $files]
}

#
# Files
#
# Parameters:
#	none
#
# Return:
#	list of files
#
proc Files {} {
	variable files
	return $files
}

#
# AddFiles
#
# Parameters:
#	newfiles, list of files to add
#
# Return:
#	none
#
proc AddFiles { newfiles } {
	variable files
	foreach newfile $newfiles {
		if {[file exists $newfile]} {
			if {[file isdirectory $newfile]} {
				AddFiles [glob -nocomplain -directory $newfile *]
			} elseif {[file isfile $newfile]} {
				lappend files $newfile
			}
		}
	}
}

#
# RemoveFiles
#
# Parameters:
#	indices, optional list of indices of file entries to remove
#		(if not specified, all file entries are removed)
#
# Return:
#	none
#
proc RemoveFiles { {indices {}} } {
	variable files
	if {$indices == {}} {
		set files {}
	} else {
		foreach index [lsort -decreasing $indices] {
			set files [lreplace $files $index $index]
		}
	}
}

}
