package provide ZipFiles 1.0

namespace eval ZipFiles {

# public procedures
namespace export ZipFiles

#
# ZipFiles
#
# Parameters:
#	files, list of file paths to zip
#	dataVar, variable to hold zipped content
#
# Return:
#	length of zipped data
#	otherwise error
#
proc ZipFiles { files dataVar status } {
	upvar $dataVar data
	
	# -q: quiet (no diagnostic messages)
	# -9: highest compression ratio
	# -j: flatten directories (compress files only)
	#  -: write zip file to standard output
	eval $status {"Zipping files..."}
	if {[catch {open "|/usr/bin/zip -q -9 -j - $files" r} zipPipe]} {
		return -code error $zipPipe
	}
	
	# pipe the zipped data into the provided variable
	fconfigure $zipPipe -translation binary -encoding binary
	set data [read $zipPipe]
	close $zipPipe
	
	# report byte count
	return [string length $data]
}

}
